/*

  Copyright  Grame 1999

  This library is free software; you can redistribute it and modify it under 
  the terms of the GNU Library General Public License as published by the 
  Free Software Foundation version 2 of the License, or any later version.

  This library is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
  or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Library General Public License 
  for more details.

  You should have received a copy of the GNU Library General Public License
  along with this library; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

  Grame Research Laboratory, 9, rue du Garet 69001 Lyon - France
  grame@rd.grame.fr

*/

/*****************************************************************************/
/* PlayerState class : data structure used for the Player state management
/*****************************************************************************/

package grame.midishare.player;

/**
This class describes a Player state.
*@see grame.midishare.player.MidiPlayer#GetState
*@see grame.midishare.player.MidiPlayer#GetEndScore
*/

public class  PlayerState
{
	// MIDIfile 
	
	/** the current date in milliseconds. */
	public int date;
	/** the current tempo in microsec/per/quaternote. */
	public int tempo;
	/** the current time signature: Numerator. */
	public short tsnum;
	/** the current time signature: denominator in power of two. */
	public short tsdenom;
	/** the current time signature: Midi Clocks per metronome clicks. */
	public short tsclick;
	/** the current time signature: notated 32th of note per quarter-note. */
	public short tsquarter;
	/** the current position in musical time: bar*/
	public short bar;
	/** the current position in musical time: beat*/
	public short beat;
	/** the current position in musical time: unit*/
	public short unit;
	/** the current state.
	*@see grame.midishare.player.MidiPlayer
	 */
	public short state;
	/** the current input synchronisation state. 
	*@see grame.midishare.player.MidiPlayer
	*/
	public short syncin;
	/** the current output synchronisation state. 
	*@see grame.midishare.player.MidiPlayer
	*/
	public short syncout;
}